/**
 * 
 */
package net.gorry.android.input.nicownng;

import java.util.List;

import android.content.Context;
import android.inputmethodservice.Keyboard;
import android.util.Log;

/**
 * 
 * 高さを変更できるキーボード
 * 
 * @author GORRY
 *
 */
public class MyHeightKeyboard extends Keyboard {
	private static final String TAG = "MyHeightKeyboard";
	private static final boolean V = false;

	private static final int keyHeightTablePortrait[] = {
		36, 48, 60, 72, 84, 96, 108, 120,
	};
	private static final int keyHeightTableLandscape[] = {
		24, 36, 48, 60, 72, 84, 96, 108,
	};

	private int mTotalHeight;

	private static final int popupKeyboardTable_12key[] = {
		R.xml.keyboard_popup_12key_jp_0,
		R.xml.keyboard_popup_12key_jp_1,
		R.xml.keyboard_popup_12key_jp_2,
		R.xml.keyboard_popup_12key_jp_3,
		R.xml.keyboard_popup_12key_jp_4,
		R.xml.keyboard_popup_12key_jp_5,
		R.xml.keyboard_popup_12key_jp_6,
		R.xml.keyboard_popup_12key_jp_7,
	};
	
	private static final int popupKeyboardTable_qwerty[] = {
		R.xml.keyboard_popup_qwerty_jp_0,
		R.xml.keyboard_popup_qwerty_jp_1,
		R.xml.keyboard_popup_qwerty_jp_2,
		R.xml.keyboard_popup_qwerty_jp_3,
		R.xml.keyboard_popup_qwerty_jp_4,
		R.xml.keyboard_popup_qwerty_jp_5,
		R.xml.keyboard_popup_qwerty_jp_6,
		R.xml.keyboard_popup_qwerty_jp_7,
	};
	
	private static final int popupKeyboardTable_nico2[] = {
		R.xml.keyboard_popup_nico2_jp_0,
		R.xml.keyboard_popup_nico2_jp_1,
		R.xml.keyboard_popup_nico2_jp_2,
		R.xml.keyboard_popup_nico2_jp_3,
		R.xml.keyboard_popup_nico2_jp_4,
		R.xml.keyboard_popup_nico2_jp_5,
		R.xml.keyboard_popup_nico2_jp_6,
		R.xml.keyboard_popup_nico2_jp_7,
	};

	private static final int popupKeyboardTable[][] = {
		popupKeyboardTable_12key,  // KEYTYPE_12KEY
		popupKeyboardTable_qwerty, // KEYTYPE_QWERTY
		popupKeyboardTable_nico2,  // KEYTYPE_NICO2
	};

	/**
	 * @param context context
	 * @param xmlLayoutResId resid
	 * @param heightIndex height
	 * @param isPortrait portrait
	 */
	public MyHeightKeyboard(Context context, int xmlLayoutResId, int heightIndex, int keyType, boolean isPortrait) {
		super(context, xmlLayoutResId);
		
		final int[] htable = (isPortrait ? keyHeightTablePortrait : keyHeightTableLandscape);
		final int height = htable[heightIndex];
		List<Key> keys = this.getKeys();
		// Log.d("nicoWnnG", "keys.size="+keys.size());
		int maxy = 0;
		int maxheight = 0;
		for (int i=0; i<keys.size(); i++) {
			Key key = keys.get(i);
			// Log.d("nicoWnnG", i+": w="+key.width+",h="+key.height+",label="+key.label+",text="+key.text);

			// ポップアップキーボードのサイズ変更
			if (key.codes.length > 0) {
				if (key.codes[0] == DefaultSoftKeyboard.KEYCODE_JP12_TOGGLE_MODE) {
					int n = 0;
					for (int j=0; j<htable.length; j++) {
						if (height >= htable[j]) {
							n = j;
						}
					}
					key.popupResId = popupKeyboardTable[keyType][n];
					// Log.d("nicoWnnG", "resourceName="+context.getResources().getResourceName(key.popupResId));
				}
			}
			
			// キーサイズ変更
			key.y *= height;
			key.height *= height;
			if (maxy < key.y) {
				maxy = key.y;
				maxheight = 0;
			}
			if (maxheight < key.height) {
				maxheight = key.height;
			}
		}
		mTotalHeight = maxy + maxheight;
	}

	@Override
	public int getHeight() {
		return mTotalHeight;
	}
}
